IOSS 2.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Static Protected Member Functions | Private Member Functions | Static Private Member Functions | Private Attributes | List of all members
Ioss::VariableType Class Referenceabstract

A generic variable type. More...

`#include <Ioss_VariableType.h>`

Inheritance diagram for Ioss::VariableType:
[legend]

## Public Member Functions
virtual | ~VariableType ()
int | component_count () const
virtual int | suffix_count () const
std::string | name () const
virtual std::string | label (int which, char suffix_sep='_') const =0
virtual std::string | label_name (const std::string &base, int which, char suffix_sep='_') const
virtual bool | match (const std::vector< Suffix > &suffices) const

## Static Public Member Functions
static void | alias (const std::string &base, const std::string &syn)
static int | describe (NameList *names)
| Get the names of variable types known to IOSS. More...
static bool | create_named_suffix_field_type (const std::string &type_name, const std::vector< std::string > &suffices)
static bool | get_field_type_mapping (const std::string &field, std::string *type)
static bool | add_field_type_mapping (const std::string &raw_field, const std::string &raw_type)
static std::string | numeric_label (int which, int ncomp, const std::string &name)
static const VariableType * | factory (const std::string &raw_name, int copies=1)
static const VariableType * | factory (const std::vector< Suffix > &suffices)

## Protected Member Functions
| VariableType (const std::string &type, int comp_count, bool delete_me=false)

## Static Protected Member Functions
static Registry & | registry ()

## Private Member Functions
| VariableType (const VariableType &)=delete
VariableType & | operator= (const VariableType &)=delete

## Static Private Member Functions
static bool | build_variable_type (const std::string &raw_type)

## Private Attributes
const std::string | name_
int | componentCount

## Detailed Description

A generic variable type.

## Constructor & Destructor Documentation

## ◆ ~VariableType()

Ioss::VariableType::~VariableType | ( |  | ) |
| virtualdefault

## ◆ VariableType() [1/2]

Ioss::VariableType::VariableType | ( | const std::string & | type,
|  | int | comp_count,
|  | bool | delete_me = `false`
| ) |  |
| protected

## ◆ VariableType() [2/2]

Ioss::VariableType::VariableType | ( | const VariableType & |  | ) |
| privatedelete

## Member Function Documentation

## ◆ add_field_type_mapping()

bool Ioss::VariableType::add_field_type_mapping | ( | const std::string & | raw_field,
|  | const std::string & | raw_type
| ) |  |
| static

## ◆ alias()

void Ioss::VariableType::alias | ( | const std::string & | base,
|  | const std::string & | syn
| ) |  |
| static

## ◆ build_variable_type()

bool Ioss::VariableType::build_variable_type | ( | const std::string & | raw_type | ) |
| staticprivate

## ◆ component_count()

int Ioss::VariableType::component_count | ( |  | ) | const
| inline

## ◆ create_named_suffix_field_type()

bool Ioss::VariableType::create_named_suffix_field_type | ( | const std::string & | type_name,
|  | const std::vector< std::string > & | suffices
| ) |  |
| static

## ◆ describe()

int Ioss::VariableType::describe | ( | NameList * | names | ) |
| static

Get the names of variable types known to IOSS.

Parameters

  [out] | names | The list of known variable type names.

Returns
  The number of known variable types.

## ◆ factory() [1/2]

const VariableType * Ioss::VariableType::factory | ( | const std::string & | raw_name,
|  | int | copies = `1`
| ) |  |
| static

## ◆ factory() [2/2]

const VariableType * Ioss::VariableType::factory | ( | const std::vector< Suffix > & | suffices | ) |
| static

## ◆ get_field_type_mapping()

bool Ioss::VariableType::get_field_type_mapping | ( | const std::string & | field,
|  | std::string * | type
| ) |  |
| static

## ◆ label()

virtual std::string Ioss::VariableType::label | ( | int | which,
|  | char | suffix_sep = `'_'`
| ) |  | const
| pure virtual

Implemented in Ioss::ElementVariableType, Ioss::NamedSuffixVariableType, Ioss::Matrix_33, Ioss::Matrix_22, Ioss::Asym_Tensor_01, Ioss::Asym_Tensor_02, Ioss::Asym_Tensor_03, Ioss::Sym_Tensor_10, Ioss::Sym_Tensor_11, Ioss::Sym_Tensor_13, Ioss::Sym_Tensor_21, Ioss::Sym_Tensor_31, Ioss::Sym_Tensor_33, Ioss::Full_Tensor_12, Ioss::Full_Tensor_16, Ioss::Full_Tensor_22, Ioss::Full_Tensor_32, Ioss::Full_Tensor_36, Ioss::Quaternion_3D, Ioss::Quaternion_2D, Ioss::Vector_3D, Ioss::Vector_2D, Ioss::Scalar, Ioss::Invalid_Storage, Ioss::CompositeVariableType, and Ioss::ConstructedVariableType.

## ◆ label_name()

std::string Ioss::VariableType::label_name | ( | const std::string & | base,
|  | int | which,
|  | char | suffix_sep = `'_'`
| ) |  | const
| virtual

Reimplemented in Ioss::ElementVariableType, Ioss::Scalar, and Ioss::Invalid_Storage.

## ◆ match()

bool Ioss::VariableType::match | ( | const std::vector< Suffix > & | suffices | ) | const
| virtual

## ◆ name()

std::string Ioss::VariableType::name | ( |  | ) | const
| inline

## ◆ numeric_label()

std::string Ioss::VariableType::numeric_label | ( | int | which,
|  | int | ncomp,
|  | const std::string & | name
| ) |  |
| static

## ◆ operator=()

VariableType& Ioss::VariableType::operator= | ( | const VariableType & |  | ) |
| privatedelete

## ◆ registry()

Registry & Ioss::VariableType::registry | ( |  | ) |
| staticprotected

## ◆ suffix_count()

int Ioss::VariableType::suffix_count | ( |  | ) | const
| inlinevirtual

Reimplemented in Ioss::Scalar, Ioss::Invalid_Storage, and Ioss::ElementVariableType.

## Member Data Documentation

## ◆ componentCount

int Ioss::VariableType::componentCount
| private

## ◆ name_

const std::string Ioss::VariableType::name_
| private

The documentation for this class was generated from the following files:

- src/Ioss_VariableType.h
- src/Ioss_VariableType.C